--###################################################################################--
--###################################################################################--

									-- ___                     
								   -- (   )                    
				 -- .-.    .---.    .-.| |    .--.     .--.    
				-- ( __)  / .-, \  /   \ |   /    \   /    \   
				-- (''") (__) ; | |  .-. |  |  .-. ; |  .-. ;  
				 -- | |    .'`  | | |  | |  |  | | | |  |(___) 
				 -- | |   / .'| | | |  | |  |  |/  | |  |      
				 -- | |  | /  | | | |  | |  |  ' _.' |  | ___  
				 -- | |  ; |  ; | | '  | |  |  .'.-. |  '(   ) 
			 -- ___ | |  ' `-'  | ' `-'  /  '  `-' / '  `-' |  
			-- (   )' |  `.__.'_.  `.__,'    `.__.'   `.__,'   
			 -- ; `-' '                                        
			  -- .__.'                                         
			  
--###################################################################################--
--								just a 'dark echo' clone							 --
--###################################################################################--

			  -- _                _                   _ _   _       
			 -- | |__  _   _     / \   ___ ___  _ __ (_) |_(_)_ __  
			 -- | '_ \| | | |   / _ \ / __/ _ \| '_ \| | __| | '_ \ 
			 -- | |_) | |_| |  / ___ \ (_| (_) | | | | | |_| | | | |
			 -- |_.__/ \__, | /_/   \_\___\___/|_| |_|_|\__|_|_| |_|
					-- |___/                                        

--###################################################################################--
--								     aconitin@gmx.de								 --
--###################################################################################--
-------------editor width: you must be at least this wide to enjoy the ride-------------
		
--[[
	prefixes:
	classes: _ (or c_)
	instances: i_
	global variables: __
--]]

--> Configuration file that can be altered by the user!
require("config")

--> Require hump library (or, parts of it)!
_hump = {}
_hump.timer = require("hump/timer")
--_hump.signal = require("hump/signal")



			require("_gamestates")
			_gamestates.splash = require("outsourced/misc_gamestates_splash")
			_gamestates.intro = require("outsourced/misc_gamestates_intro")
			_gamestates.leaving = require("outsourced/misc_gamestates_leaving")
			_gamestates.menu = require("outsourced/misc_gamestates_menu")
			_gamestates.ingame = require("outsourced/misc_gamestates_ingame")


--> Entites ("things")!
require("entity_line")
_line.profiles = require("outsourced/entity_line_profiles")

--> Other misc stuff!
require("misc_map")
_map.tiles = require("outsourced/misc_map_tileDefinitions") --> Definition of tiles used by the map!
require("misc_loveGraphicsLineReplacement") --> Replace love.graphics.line because it is bugged as fuck!
require("misc_romanNumerals")
require("misc_collider") --> _collider class calls individual collide() functions on collision events!
_collider.hardonCollider = require("HardonCollider")

			require("_controller")

			require("_player")
			require("_afx")
			require("_footstep")
			
			require("_dottedMovingLine")
			require("_stone")
			require("_expandingCircle")
			_gamera = require("Gamera/gamera")


--> Require enemies!
require("enemy_whisp")
require("enemy_boomerang")
require("enemy_boomerangTrap")
require("enemy_lindworm")

--> Gets called once on game start!
function love.load(args)
	--> Set seed!
	love.math.setRandomSeed(os.time())
	love.math.random()
	love.math.random()

	--> Set global variables!
	__dtCount = 0 --> For fixed update!
	__drawColliders = false --> Don't change. Toggles drawing of colliders!
	__debugFont = love.graphics.newFont(12)
	__debugMenu = false

	--> Initialize some libraries!
	_afx:init({"sfx", "music"})
	_collider.init()

	--> Switch to gamestate!
	_gamestates.switchTo("splash")
end

--> Draw function!
function love.draw()
	_gamestates[_gamestates.current].draw()
	love.graphics.setColor(255, 255, 255, 255) --> No idea why, but this fixes some weird intro bug, so don't remove it!
	--> Draw debug menu text!
	if __debugMenu then
		love.graphics.setFont(__debugFont)
		love.graphics.print("Debug keys (Toggle with ctrl + alt + m + return):\n1: Toggle Collider Drawing\n2: Toggle fixed dt\n3: Superspeed", 0, 0)
	end
end

--> Standard update function!
function love.update(dt)
	--> Draw title!
	if __debugMenu then
		local cs, cp, cv, csf, cy = _afx:getAllCounts()
		local mapWorking = false
		if _map.creation.cor then
			mapWorking = true
		end
		love.window.setTitle("Jadec  - FPS: " .. love.timer.getFPS() .. " | fixedDt: " .. tostring(_G.configuration.useFixedDT) .. " | #Lines: " .. #_line.instances .. " | #fp: " .. #_footstep.instances .. " | #hunter: " .. #_whisp.instances .. " || afx: " .. cs .. " cs, " .. cp .. " cp, " .. cv .. " cv, " .. csf .. " csf, " .. cy .. " cy || #Maps: " .. #_map.instances .. ", wrk: " .. tostring(mapWorking) .. " || #players: " .. #_player.instances)
	else
		love.window.setTitle("Jadec by Aconitin")
	end
	--> Use fixed dt update (or not)!
	if _G.configuration.useFixedDT then
		__dtCount = __dtCount + dt
		while __dtCount >= _G.configuration.fixedDTStep do
			__dtCount = __dtCount - _G.configuration.fixedDTStep
			_gamestates[_gamestates.current].update(_G.configuration.fixedDTStep)
		end
	else
		_gamestates[_gamestates.current].update(dt)
	end
end

--> Callback for key pressed!
function love.keypressed(key, scancode, isRepeat)
	--> Exit game on alt + f4!
	if love.keyboard.isDown("alt") and love.keyboard.isDown("f4") then
		love.event.quit()
	elseif love.keyboard.isDown("lctrl") and love.keyboard.isDown("lalt") and love.keyboard.isDown("m") and love.keyboard.isDown("return") then
		__debugMenu = not __debugMenu --> Enable debug menu on ctrl + alt + m + return!
	else	
		_controller:keypressed(key, isRepeat)
	end
	--> Debug menu keys!
	if __debugMenu then
		if key == "1" then
			__drawColliders = not __drawColliders
		elseif key == "2" then
			_G.configuration.useFixedDT = not _G.configuration.useFixedDT
		elseif key == "3" then
			for i,v in ipairs(_player.instances) do
				v.s = 500
			end
		end
	end
	if _gamestates[_gamestates.current].keypressed then --> More or less just for skipping the outro!
		_gamestates[_gamestates.current].keypressed(key)
	end
end

function love.mousepressed(x, y, button)
	_controller:mousepressed(x, y, button)

	if _gamestates[_gamestates.current].mousepressed then --> More or less just for skipping the outro!
		_gamestates[_gamestates.current].mousepressed()
	end
end

function love.mousereleased(x, y, button)
	_controller:mousereleased(x, y, button)
end

function love.keyreleased(key)
	_controller:keyreleased(key)
end

function love.gamepadpressed(joystick, button)
	_controller:gamepadpressed(joystick, button)
	if _gamestates[_gamestates.current].gamepadpressed then --> More or less just for skipping the outro!
		_gamestates[_gamestates.current].gamepadpressed()
	end
end

function love.gamepadreleased(joystick, button)
	_controller:gamepadreleased(joystick, button)
end

